# Set the item external reference in the InLine Cart

## Overview

Use the Product object to set **item external reference** by setting the **externalReference** property.

## Use case

1. Add an HTML link or button in your page like the one below.
2. Create a JavaScript click handler to execute the Inline Client desired methods.
3. Set dynamic mode using`TwoCoInlineCart.setup.setMode('DYNAMIC')`.
4. Use the`TwoCoInlineCart.products.add({name, quantity, price, options, externalReference})`method to prepare your dynamic product.
5. You can see below a signature token request payload for this example. A success response contains a JSON with the property “signature“ which needs to be used at the next step to set the signature using the TwoCoInlineCart method.<br>

   ```javascript
   {
       "merchant": "2COLRNC",
       "dynamic": "1",
       "currency": "USD",
       "products": [
           {
               "name": "A test dynamic product",
               "price": 10,
               "reference": {
                   "external": {
                       "item": "test-item-external-ref"
                   }
               }
           }
       ]
   }
   ```

   \
   The above payload will generate the signature 794da13570fbd72d7ffb970b7b16390508c1ac5581e829a811c5301f5e5bc0f3.
6. Use the TwoCoInlineCart.cart.setSignature('794da13570fbd72d7ffb970b7b16390508c1ac5581e829a811c5301f5e5bc0f3') method to set the signature. It is important that you employ TwoCoInlineCart.cart.removeAll() just before the TwoCoInlineCart.products.addMany(products) or TwoCoInlineCart.products.add(product) methods to remove previous products as the signature is based on the products' definition.
7. Use the`TwoCoInlineCart.cart.checkout()`method to show the cart on your page.

## Sample request

### HTML

```html
<a href="#" class="btn btn-success" id="buy-button">Buy now!</a>
```

### Javascript

```javascript
window.document.getElementById('buy-button').addEventListener('click', function() {
  TwoCoInlineCart.setup.setMode('DYNAMIC');
  TwoCoInlineCart.cart.setCurrency('USD');
  TwoCoInlineCart.products.add({
    name: "A test dynamic product",
    price: 10,
    externalReference: 'test-item-external-ref'
  });
  TwoCoInlineCart.cart.setSignature('794da13570fbd72d7ffb970b7b16390508c1ac5581e829a811c5301f5e5bc0f3');
  TwoCoInlineCart.cart.checkout();
});
```

## Demo

After setting the item external reference in the InLine cart using the above method, your cart should look like this:

{% embed url="<https://codepen.io/2checkout-documentation/pen/LKVraB>" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/shopping-carts/inline/use-cases/set-the-item-external-reference-in-the-inline-cart.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
